use std::{
    fs::{self},
    path::PathBuf,
};

use clap::Parser;
use log::info;
use raqote::DrawTarget;

use parse::parse_the_shit_out_of_this_but_manually;

use render::render_text;

use crate::error::DiagnosticReporter;

mod error;
mod parse;
mod render;

#[derive(Clone, Debug, Parser)]
struct Args {
    #[arg(short, default_value = "1920")]
    x: u16,
    #[arg(short, default_value = "1080")]
    y: u16,
    // swt means "Hyper Some Web Thing"
    #[arg(short, long)]
    file: PathBuf,
}

fn main() {
    simple_logger::init().unwrap();
    let args = Args::parse();

    info!(
        "Henlo world, resolution to render to is {}*{}px",
        args.x, args.y
    );

    let mut reporter = DiagnosticReporter::new();

    let txt = fs::read_to_string(args.file.clone()).unwrap();

    let fid = reporter.register_file(args.file.file_name().unwrap().to_str().unwrap(), &txt);

    dbg!(parse_the_shit_out_of_this_but_manually(
        &txt,
        &mut reporter,
        &fid
    ));

    let mut dt = DrawTarget::new(args.x.into(), args.y.into());

    render_text(&mut dt);

    dt.write_png("out.png").unwrap();
}
